//---------------------------------------------------------------------------
#include "stdafx.h"
#include <sstream>
#include "XlsHelpers.h"
#include "DemoHelpers.h"
//---------------------------------------------------------------------------
CDemoHelpers::CDemoHelpers()
{
}
//---------------------------------------------------------------------------
CDemoHelpers::~CDemoHelpers()
{
}
//---------------------------------------------------------------------------
bool CDemoHelpers::SaveCommon( const std::string& strFilePath,
							   WTL::CProgressBarCtrl*	progress)
{
try
{
	unsigned int timeMilli = ::GetTickCount();
	//
	const char* worksheetName = "Formatted data";
	const char* colStringText		= "B";
	const char* colStringNumbers	= "C";
	unsigned short colIndText		= XlsHelpers::ColStringToColInd( colStringText);
	unsigned short colIndNumbers	= XlsHelpers::ColStringToColInd( colStringNumbers);

	unsigned short rowIndHeader = 2;
	unsigned short rowIndLast	= 10005;

	XlsHelpers::SetRowHeight(worksheetName, rowIndHeader, 20);
	XlsHelpers::SetColWidth(worksheetName, colIndText, 23);
	XlsHelpers::SetColWidth(worksheetName, colIndNumbers, 14);
	//
	XlsHelpers::SetRangeText(
		worksheetName, rowIndHeader, colIndText, "Text",
		"Arial", 12,
		true, false, false, 
		CInterior::ALIGN_HORZ_CENTER, 
		CInterior::ALIGN_VERT_CENTER,
		CInterior::LINE_STYLES_THIN, 
		CInterior::LINE_STYLES_THIN, 
		CInterior::LINE_STYLES_NONE, 
		CInterior::LINE_STYLES_THIN);

	XlsHelpers::SetRangeText(
		worksheetName, rowIndHeader, colIndNumbers, "Number",
		"Arial", 12,
		true, false, false,
		CInterior::ALIGN_HORZ_CENTER, 
		CInterior::ALIGN_VERT_CENTER,
		CInterior::LINE_STYLES_THIN, 
		CInterior::LINE_STYLES_THIN, 
		CInterior::LINE_STYLES_THIN, 
		CInterior::LINE_STYLES_THIN);

	if( progress)
		progress->SetPos(1);

		// huge number of cells
	unsigned short i = rowIndHeader + 1;
    for(; i <= rowIndLast; i++)
    {
		XlsHelpers::SetRangeText(
			worksheetName, i, colIndText, "See formula at the bottom",
			"Verdana", 8,
			false, false, false,
			CInterior::ALIGN_HORZ_GENERAL, 
			CInterior::ALIGN_VERT_BOTTOM,
			CInterior::LINE_STYLES_NONE, 
			CInterior::LINE_STYLES_NONE, 
			CInterior::LINE_STYLES_NONE, 
			CInterior::LINE_STYLES_NONE);
		//
		XlsHelpers::SetRangeNumber(
			worksheetName, i, colIndNumbers, i,
			"Verdana", 8,
			false, false, false,
			CInterior::ALIGN_HORZ_GENERAL, 
			CInterior::ALIGN_VERT_BOTTOM,
			CInterior::LINE_STYLES_NONE, 
			CInterior::LINE_STYLES_NONE, 
			CInterior::LINE_STYLES_NONE, 
			CInterior::LINE_STYLES_NONE);
    }
	// total
	XlsHelpers::SetRangeText(
		worksheetName, i, colIndText, "Total",
		"Verdana", 8,
		true, false, false,
		CInterior::ALIGN_HORZ_GENERAL, 
		CInterior::ALIGN_VERT_BOTTOM,
		CInterior::LINE_STYLES_THIN, 
		CInterior::LINE_STYLES_THIN, 
		CInterior::LINE_STYLES_THIN, 
		CInterior::LINE_STYLES_THIN);
	//
	std::ostringstream formula;
	formula << "=SUM("	<< colStringNumbers << rowIndHeader + 1 
			<< ':'		<< colStringNumbers << rowIndLast
			<< ")";

	XlsHelpers::SetRangeFormula(
		worksheetName, i, colIndNumbers, formula.str().c_str(),
		"Verdana", 8,
		true, false, false, 
		CInterior::ALIGN_HORZ_GENERAL, 
		CInterior::ALIGN_VERT_BOTTOM,
		CInterior::LINE_STYLES_THIN, 
		CInterior::LINE_STYLES_THIN, 
		CInterior::LINE_STYLES_THIN, 
		CInterior::LINE_STYLES_THIN);

	if( progress)
		progress->SetPos(2);

        //=================================
	timeMilli = ::GetTickCount() - timeMilli;
    double timeSec = ((double)timeMilli / 1000.0) + 1.0;

	std::ostringstream timeAsText;
	timeAsText << "It took ";
	timeAsText.precision(4);
	timeAsText << timeSec << " seconds to create and write down this file";

	XlsHelpers::SetRangeText(
		worksheetName, 1, 4, timeAsText.str().c_str(),
		"Verdana", 20,
		true, false, false,
		CInterior::ALIGN_HORZ_GENERAL, 
		CInterior::ALIGN_VERT_BOTTOM,
		CInterior::LINE_STYLES_NONE, 
		CInterior::LINE_STYLES_NONE, 
		CInterior::LINE_STYLES_NONE, 
		CInterior::LINE_STYLES_NONE);

	if( progress)
		progress->SetPos(13);

	XlsHelpers::Save( strFilePath.c_str());

	if( progress)
		progress->SetPos(14);
	return true;
}
catch( std::runtime_error& e)
{
	::MessageBox( NULL, e.what(), "", MB_OK);
}
    return false;
}
//---------------------------------------------------------------------------
